#!/bin/sh
# Demonstrate how to make API documentation of a Python 
# module, using Sphinx.

# Clean up generated files:
rm -rf _build _static _templates conf.py index.txt docex_sphinx.txt

# Generate .txt file for module docex_sphinx:
cat > docex_sphinx.txt <<EOF

:mod:\`docex_sphinx\`
=======================

.. automodule:: docex_sphinx
   :members:
   :undoc-members:
   :show-inheritance:


EOF

# Let Sphinx generate the files it needs:
sphinx-quickstart <<EOF
.
n
_
Sphinx Example
An Author
0.1
0.1
.txt
index
n
y
n
n
n
n
y
n
n
y
y
y
EOF

# Edit the generated conf.py file (generated by the above command)
# to reflect where the source directory of the module is located (os.curdir):
scitools subst '\#sys\.path\.append.+' "sys.path.append(os.path.join(os.path.abspath(os.curdir)))" conf.py

# Insert list of modules in the file index.txt (generated above):
scitools subst ':maxdepth: 2' ":maxdepth: 1\n\n   docex_sphinx\n" index.txt

# Generate HTML documentation:
make html

# Generated files:
ls _build/html
